unit ComponentContainer;

interface

uses
  SysUtils, Classes, Vcl.Controls;

type

  TmcMode = (mcSave, mcLoad);

type
  TcomponentEX = class(TComponent)
  private
    FTagString: string;
  published
    property TagString: string read FTagString write FTagString;
  end;

  { rsqhmfrPɕۑ邽߂̃Rei[ }
type
  TStringsContainerX = class(TcomponentEX)

  private

    FStrings: TStrings;
    procedure SetStringsMemo(const Value: TStrings);

  public
    constructor Create(aowner: TComponent); override;
    destructor Destroy; override;

  protected
  published
    property Strings: TStrings read FStrings write SetStringsMemo;

  end;

  { R|[lgPɕۑ邽߂̃Rei[ }
type
  TMemoryStreamContainerX = class(TcomponentEX)
  private
    FMemoryStream: TMemoryStream;
    FExecuteMode: TmcMode;
    FTargetComponent: TComponent;
    FExecute: Boolean;
    procedure SetExecute(const Value: Boolean);
    procedure SetExecuteMode(const Value: TmcMode);
    procedure SetTargetComponent(const Value: TComponent);
  protected
    { Protected 錾 }
    procedure Notification(aComponent: TComponent; Operation: TOperation); override;
  Public
    constructor Create(aowner: TComponent); override;
    destructor Destroy; override;

    function SaveProperties(aComponent: TComponent): Boolean; overload;
    function SaveProperties: Boolean; overload;

    function LoadProperties(aComponent: TComponent): Boolean; overload;
    function LoadProperties: Boolean; overload;

  published
    property TargetComponent: TComponent read FTargetComponent write SetTargetComponent; // ۑER|[lg
    property ExecuteMode: TmcMode read FExecuteMode write SetExecuteMode; // s郂[h
    property Execute: Boolean read FExecute write SetExecute; // s

  end;

  { R|[lgt@C[ɕۑ邽߂̃Rei[ }

type
  TComponentContainer = class(TcomponentEX)
  private
    FTargetComponent: TComponent;
    FFileName: TFileName;
    FExecuteMode: TmcMode;
    FExecute: Boolean;

    FChildCOmponentsList: TStringsContainerX;

    procedure SetTargetComponent(const Value: TComponent);
    procedure SetExecuteMode(const Value: TmcMode);
    procedure SetExecute(const Value: Boolean);
    procedure SetchildCOmponentsList(const Value: TStringsContainerX);

    { Private 錾 }
  protected
    { Protected 錾 }
    procedure Notification(aComponent: TComponent; Operation: TOperation); override;
  public
    { Public 錾 }
    constructor Create(aowner: TComponent); override;
    destructor Destroy; override;

    function SaveProperties: Boolean; overload;
    function SaveProperties(aFileName: string): Boolean; overload;

    function LoadProperties: Boolean; overload;
    function LoadProperties(aFileName: string): Boolean; overload;

  published
    { Published 錾 }

    { ĂȂ

      q̃R|[lgɕۑ
      ew肵Ă̏ɑޔR|[lg𕜌


    }
    property TargetComponent: TComponent read FTargetComponent write SetTargetComponent; // ۑER|[lg
    property FileName: TFileName read FFileName write FFileName; // Oۑt@C
    property ExecuteMode: TmcMode read FExecuteMode write SetExecuteMode; // s郂[h
    property Execute: Boolean read FExecute write SetExecute; // s
  end;

  { I[i[̃R|[lgq̃R|[lg̏o }
type
  TComponentsListUp = Class(TcomponentEX)
  private
    FExecute: Boolean;
    FownerCompo: TComponent;
    FComponentsList: TStringsContainerX;
    procedure SetExecute(const Value: Boolean);
    procedure SetownerCompo(const Value: TComponent);
    procedure SetComponentsList(const Value: TStringsContainerX);
    function GetComponentInfos(const inComponent: TComponent; var level: integer; Var ComponentsList: TStringsContainerX): Boolean;
    function GetComponentsInfos(const inComponent: TComponent; var level: integer; Var ComponentsList: TStringsContainerX): Boolean;

  protected
  public
      constructor Create(aowner: TComponent); override;
    destructor Destroy; override;
    procedure ListupAllComponents; overload;
    procedure ListupAllComponents(OwnerComponent: TComponent); overload;

  published
    property ownerCompo: TComponent read FownerCompo write SetownerCompo;
    property Execute: Boolean read FExecute write SetExecute;
    property ComponentsList: TStringsContainerX read FComponentsList write SetComponentsList;
  End;

type
  TControlX = class(TControl)
  private
    FTagString: string;
    procedure SetTagString(const Value: string);
  published
    property TagString: string read FTagString write SetTagString;
  end;

type
  TWINControlX = class(TWINControl)
  private
    FTagString: string;

  published
    property TagString: string read FTagString write FTagString;
  end;

  // procedure Register;

implementation

{
  procedure Register;
  begin
  RegisterComponents('f', [TComponentContainer, TComponentsListUp, TStringsContainerX, TControlX,TWINControlX]);
  end;
}
Uses
  Vcl.forms, System.TypInfo;

procedure FreeCompo(propetyCompo, aComponent: TComponent);
begin
  if propetyCompo <> nil then
  begin
    if aComponent = propetyCompo then
    begin
      propetyCompo := nil;
    end;
  end;
end;

procedure SetStrings(inStr, outstr: TStrings);
begin
  if outstr.Text <> inStr.Text then
  begin
    outstr.BeginUpdate;
    try
      outstr.Assign(inStr);
    finally
      outstr.EndUpdate;
    end;
  end;
end;

{ TStringsContainerX }

constructor TStringsContainerX.Create(aowner: TComponent);
begin
  inherited;
  FStrings := TStringList.Create;
  TagString := '̕ۑ ';
end;

destructor TStringsContainerX.Destroy;
begin
  FreeAndNil(FStrings);
  inherited;

end;

procedure TStringsContainerX.SetStringsMemo(const Value: TStrings);
begin
  SetStrings(Value, FStrings);


end;

{ TMemoryStreamContainerX }

constructor TMemoryStreamContainerX.Create(aowner: TComponent);
begin
  inherited;
  FMemoryStream := TMemoryStream.Create;
  TagString := '.ꎟۊ';

end;

destructor TMemoryStreamContainerX.Destroy;
begin
  FreeAndNil(FMemoryStream);
  inherited;
end;



procedure TMemoryStreamContainerX.Notification(aComponent: TComponent;
  Operation: TOperation);
begin
  inherited;
  if Operation = opRemove then
  begin
    FreeCompo(FTargetComponent, aComponent);
  end;
end;

function TMemoryStreamContainerX.LoadProperties(aComponent: TComponent): Boolean;
begin
  try
    FMemoryStream.seek(0, 0);
    FMemoryStream.ReadComponent(aComponent);
    Result := True;
  except
    Result := false;
  end;
end;

function TMemoryStreamContainerX.LoadProperties: Boolean;
begin
  if Assigned(FTargetComponent) then
    Result := LoadProperties(FTargetComponent);


 //   Result := LoadProperties(self);
end;



function TMemoryStreamContainerX.SaveProperties(aComponent: TComponent): Boolean;
begin
  try
    FMemoryStream.Clear;
    FMemoryStream.WriteComponent(aComponent);
    Result := True;
  except
    Result := false;
  end;
end;

function TMemoryStreamContainerX.SaveProperties: Boolean;
begin
 if Assigned(FTargetComponent) then
    SaveProperties(FTargetComponent);


  //  SaveProperties(Self);

end;

procedure TMemoryStreamContainerX.SetExecute(const Value: Boolean);
begin
  if Value then
  begin
    case FExecuteMode of
      mcSave:
        SaveProperties();
      mcLoad:
        LoadProperties();
    end;
  end;
end;

procedure TMemoryStreamContainerX.SetExecuteMode(const Value: TmcMode);
begin
  FExecuteMode := Value;
end;

procedure TMemoryStreamContainerX.SetTargetComponent(const Value: TComponent);
begin
  FTargetComponent := Value;
end;

constructor TComponentContainer.Create(aowner: TComponent);
begin
  inherited;
  TagString := 'R|ݒ_Oۑ ' ;
end;

destructor TComponentContainer.Destroy;
begin

  inherited;
end;

procedure TComponentContainer.Notification(aComponent: TComponent;
  Operation: TOperation);
begin
  inherited;
  if Operation = opRemove then
  begin
    FreeCompo(FTargetComponent, aComponent);
    FreeCompo(FChildCOmponentsList, aComponent);
  end;

end;

procedure TComponentContainer.SetchildCOmponentsList(const Value: TStringsContainerX);
begin

end;

procedure TComponentContainer.SetExecute(const Value: Boolean);

begin

  if Value then
  begin
    case FExecuteMode of
      mcSave:
        begin
          //
          SaveProperties;
        end;
      mcLoad:
        begin
          LoadProperties;

        end;

    else
    end;
  end
  else
  begin
    // Ȃ
  end;
end;

procedure TComponentContainer.SetExecuteMode(const Value: TmcMode);
begin
  FExecuteMode := Value;
end;

function TComponentContainer.SaveProperties(aFileName: string): Boolean;
var
  aFileStream: TFileStream;
  aComponent: TComponent;
begin
  aFileStream := TFileStream.Create(aFileName, fmCreate or fmOpenWrite);
  aFileStream.WriteComponent(FTargetComponent);
  aFileStream.Free;
end;

function TComponentContainer.SaveProperties: Boolean;
begin
  SaveProperties(FFileName);
end;

function TComponentContainer.LoadProperties(aFileName: string): Boolean;
var
  aFileStream: TFileStream;
  aComponent: TComponent;
begin
  //
  Result := True;
  aFileStream := TFileStream.Create(aFileName, fmOpenRead);
  aComponent := aFileStream.ReadComponent(FTargetComponent);
  aFileStream.Free;
end;

function TComponentContainer.LoadProperties: Boolean;
begin
  Result := LoadProperties(FFileName);
end;

procedure TComponentContainer.SetTargetComponent(const Value: TComponent);
begin
  FTargetComponent := Value;
end;

{ TComponentsListUp }

procedure TComponentsListUp.SetExecute(const Value: Boolean);
begin
  if Value then
  begin
    if Assigned(FownerCompo) then

      ListupAllComponents(FownerCompo)
    else
      ListupAllComponents(Application);
  end;

end;

procedure TComponentsListUp.ListupAllComponents(OwnerComponent: TComponent);
var
  lLevel: integer;
begin
  if Assigned(FComponentsList) then
  begin
    lLevel := 0;
    FComponentsList.Strings.Clear;
    GetComponentsInfos(OwnerComponent, lLevel, FComponentsList);
  end;
end;

procedure TComponentsListUp.ListupAllComponents;
begin
  ListupAllComponents(Application);
end;

constructor TComponentsListUp.Create(aowner: TComponent);
begin
  inherited;
   Tagstring := 'R|lg@ꗗ';
end;

destructor TComponentsListUp.Destroy;
begin
     inherited;
end;

function TComponentsListUp.GetComponentInfos
  (const inComponent: TComponent; var level: integer; var ComponentsList: TStringsContainerX): Boolean;
var
  lPropList: PPropList;
  lPTypeInfo: PTypeInfo;
  lPtypeData: PtypeData;
  // lPPropInfo : PPropInfo;
  lCount: integer;
var
  i, j: integer;
  lPropObject: TObject;
  S: string;
  lClassName: string;
  lComponentInfo: string; // ɕҏWĒǉ
  llevelS: string;
begin
  Result := false;
  { KvȂ̂TƂ͂ɏĂ }
  llevelS := '%-' + IntToStr(level) + 's';

  lComponentInfo := Format(llevelS, [' ']) + inComponent.Name + '(' + inComponent.ClassName + ')';
  // ݌vTăZbg

  lPTypeInfo := inComponent.ClassInfo;
  lPtypeData := GetTypeData(lPTypeInfo);

  lCount := lPtypeData^.PropCount; // R|̃vpeC
  Getmem(lPropList, lCount * SizeOf(PPropInfo)); // memorym
  try
    GetPropInfos(lPTypeInfo, lPropList); // SẴvpeC̏荞
    for i := 0 to lCount - 1 do
    begin
      S := lPropList^[i].Name;
      IF UpperCase(S) = UpperCase('TagString') then
      begin
        lComponentInfo := lComponentInfo + GetStrProp(inComponent, lPropList^[i]);
        break;
      end;
    end;
    ComponentsList.Strings.Add(lComponentInfo);
  finally
    FreeMem(lPropList, lCount * SizeOf(PPropInfo));
  end;

end;

function TComponentsListUp.GetComponentsInfos
  (const inComponent: TComponent; var level: integer; var ComponentsList: TStringsContainerX): Boolean;
var
  lcomponent: TComponent;
var
  i: integer;

begin

  Result := True;

  { ͐eq̊KwǂĂȂ }

  for i := 0 to inComponent.ComponentCount - 1 do
  begin
    lcomponent := inComponent.Components[i];
    GetComponentInfos(lcomponent, level, ComponentsList);
  end;

end;

procedure TComponentsListUp.SetComponentsList(const Value: TStringsContainerX);
begin
  FComponentsList := Value;
end;

procedure TComponentsListUp.SetownerCompo(const Value: TComponent);
begin
  FownerCompo := Value;
end;

{ TControlX }

procedure TControlX.SetTagString(const Value: string);
begin
  FTagString := Value;
end;

end.
