unit PrinterConfig;

interface

uses

  System.SysUtils, System.Classes,
  VCL.printers, Winapi.Winspool, Winapi.windows,
  ComponentContainer;

type
  TPrinterConfig = class(TComponentEX)
  private
    { Private 錾 }
    aDrvName, aPrtName, aPortName: array [0 .. 512] of char;
    apDeviceMode, aPrinterHandle: THandle;

    aDevMode: TDevMode;
    PDevMode, PDevModeInput, PDevmodeOutput: PDeviceModeW;
    myPrintersList: TStringsContainerX;

    FPrinterDevMode: TDeviceModeW;
    FTagString: string;
    FPrinterName: string;

    procedure SetPrinterName(const Value: string);

  protected
    { Protected 錾 }
  public
    { Public 錾 }
    constructor Create(aowner: TComponent); override;
    destructor Destroy; override;

    function SaveConfig: Boolean;
    function LoadConfig: Boolean;

  published
    { Published 錾 }
    property PrinterDeviceMode: TDeviceModeW read FPrinterDevMode; // v^[̐ݒ
    property PrinterName: string read FPrinterName write SetPrinterName; // Iꂽv^

  end;

  // procedure Register;

implementation

uses vcl.Forms;        // Forms ƃG[ɂȂ@IvVȁH

{ TPrinterConfig }

constructor TPrinterConfig.Create(aowner: TComponent);
begin
  inherited;
  TagString := 'v^ݒۑ';

  myPrintersList := TStringsContainerX.Create(self);
  myPrintersList.Strings := Printer.printers;
  Printer.PrinterIndex := -1;
  Printer.GetPrinter(aDrvName, aPrtName, aPortName, apDeviceMode);

  FPrinterName := aDrvName;

end;

destructor TPrinterConfig.Destroy;
begin

  inherited;
end;

function TPrinterConfig.LoadConfig: Boolean;

// ݒ݂̃v^ɍs
begin
  // v^Jănh擾
  if OpenPrinter(PChar(FPrinterName), aPrinterHandle, nil) then
  begin
  //  Printer.SetPrinter();








        // v^
    ClosePrinter(aPrinterHandle);
  end;
end;

function TPrinterConfig.SaveConfig: Boolean;

// ݒۑ
{ hPrinter, DevMode: THandle;
  pDev: PDeviceModeW;
  pDevice, pDriver, pPort: array[0..512] of Char;
  S: string; }

var
  IDNo: integer;
var
  fMode: Dword;
begin
  // S := Printer.Printers[Printer.PrinterIndex];

  // v^Jănh擾
  if OpenPrinter(PChar(FPrinterName), aPrinterHandle, nil) then
  begin
    // v^̃foCX擾
    Printer.GetPrinter(aDrvName, aPrtName, aPortName, apDeviceMode);

    // bNA\̂ւ̃|C^擾 @@windows API

  // PDevmodeinput := GlobalLock(apDeviceMode);
    PDevmodeOutput := GlobalLock(apDeviceMode);    //
    try

      // WIN API̎s
      {
        LONG DocumentProperties(
        HWND hWnd,               // eEBhẼnh
        HANDLE hPrinter,         // v^IuWFNg̃nh
        LPTSTR pDeviceName,      // foCX
        PDEVMODE pDevModeOutput, // ύX̃[h
        PDEVMODE pDevModeInput,  // ύXÕfoCX[h
        DWORD fMode              // [h̃IvV
        );

      }


     fMode := DM_IN_PROMPT or DM_OUT_BUFFER or DM_IN_BUFFER;
   //   fMode :=  DM_PROMPT or DM_MODIFY or DM_COPY;
      IDNo := DocumentProperties
        (Application.Handle, aPrinterHandle, aDrvName, PDevmodeOutput, PDevModeInput, fMode);

      if IDNo = IDOK then
      begin
        FPrinterDevMode := PDevmodeOutput^;
      end;

    finally
      // AbN
      GlobalUnlock(apDeviceMode);
    end;

    // v^
    ClosePrinter(aPrinterHandle);
  end;
end;

procedure TPrinterConfig.SetPrinterName(const Value: string);

begin

  // Xg擾

  myPrintersList.Strings := Printer.printers;
  if myPrintersList.Strings.IndexOf(Value) = -1 then
  else
    FPrinterName := Value;

end;

end.
